class Validate
  def initialize(resp)
    @data = JSON.parse(resp)
  end

  def response_code(resp)
    if resp.code.eql? 200
      true
    else
      puts "Error Occurred and Response Top Level Keys are: #{@data.keys}"
      false
    end
  end

  def cqs_adapter_metadata(identifier)
    if @data.keys.sort.eql? EXPECTED_DIM_KEYS.sort
      true
    else
      puts "ERROR: Expected Dimension Keys not matching with keys from Response for identifier #{identifier}"
      if EXPECTED_DIM_KEYS.length > @data.keys.length
        puts "Keys missing from response: #{EXPECTED_DIM_KEYS.sort - @data.keys.sort}"
      elsif EXPECTED_DIM_KEYS.length < @data.keys.length
        puts "Extra Keys in response for CQS Adapter: #{@data.keys.sort - EXPECTED_DIM_KEYS.sort}"
      else
        puts "No Keys Diff was Expected, but still had diff: #{EXPECTED_DIM_KEYS.length - @data.keys.length}"
      end
      false
    end
  end

  def cqs_adapter_response_keys
    begin
      true if @data.keys.sort.eql? EXPECTED_DIM_KEYS.sort
    rescue
      puts "Error Comparing Keys in cqs adapter response"
      false
    end   
  end 
  
  def cqs_adapter_response_queried_dimensions(dimension_names)
    puts @data['queried_dimensions'].map { |dim| dim['name'] }.sort
    return true if @data['queried_dimensions'].empty?
    true if dimension_names.sort.eql? @data['queried_dimensions'].map { |dim| dim['name'] }.sort
  end  

  def cqs_adapter_response_queried_measures(measure_names)
    puts @data['queried_measures'].map { |measure| measure['name'] }.sort
    true if measure_names.sort.eql? @data['queried_measures'].map { |measure| measure['name'] }.sort
  end

  def key_not_null?(key)
    true unless @data["#{key}"].nil?
  end

  def get_flex_query_data_source_from_response
    @data['flexquery_datasource']
  end
end